// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.component.UIComponentBase;
import javax.faces.context.FacesContext;
import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.myfaces.tobago.component.MethodBindingToMethodExpression;
import org.apache.myfaces.tobago.component.MethodExpressionToMethodBinding;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Update the parent component
  * UIComponent class, generated from template {@code component1.2.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.ReloadTagDeclaration}.
 */
public class UIReload
    extends UIComponentBase  {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.Reload";

  public static final String COMPONENT_FAMILY = "org.apache.myfaces.tobago.Reload";

  private java.lang.Boolean update;
  private java.lang.Boolean immediate;
  private java.lang.Integer frequency;

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  /**
  Is update required.
  <br />Default: <code>true</code>
  */
  public boolean isUpdate() {
    if (update != null) {
      return update;
    }
    ValueExpression ve = getValueExpression("update");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return true;
  }

  public void setUpdate(boolean update) {
    this.update = update;
  }

  /**
  Flag indicating that
   the update check should be performed
   immediately (that is, during Apply Request Values phase) rather than
   waiting until Render Response phase.
  <br />Default: <code>true</code>
  */
  public boolean isImmediate() {
    if (immediate != null) {
      return immediate;
    }
    ValueExpression ve = getValueExpression("immediate");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return true;
  }

  public void setImmediate(boolean immediate) {
    this.immediate = immediate;
  }

  /**
  Time in milliseconds after which the parent component is automatically reloaded.
  <br />Default: <code>5000</code>
  */
  public java.lang.Integer getFrequency() {
    if (frequency != null) {
      return frequency;
    }
    ValueExpression ve = getValueExpression("frequency");
    if (ve != null) {
      try {
        Number number = (Number) ve.getValue(getFacesContext().getELContext());
        if (number != null) {
          return number.intValue();
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return 5000;
  }

  public void setFrequency(java.lang.Integer frequency) {
    this.frequency = frequency;
  }

  public void restoreState(FacesContext context, Object componentState) {
    Object[] values = (Object[]) componentState;
    super.restoreState(context, values[0]);
    update = (java.lang.Boolean) values[1];
    immediate = (java.lang.Boolean) values[2];
    frequency = (java.lang.Integer) values[3];
  }

  public Object saveState(FacesContext context) {
    Object[] values = new Object[4];
    values[0] = super.saveState(context);
    values[1] = update;
    values[2] = immediate;
    values[3] = frequency;
    return values;
  }


}