// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUIToolBar;
import org.apache.myfaces.tobago.layout.Display;
import org.apache.myfaces.tobago.layout.Measure;
import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.myfaces.tobago.component.MethodBindingToMethodExpression;
import org.apache.myfaces.tobago.component.MethodExpressionToMethodBinding;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 <p/>
  Renders a toolbar.<p />
  Allowed subcomponents are subtypes of UICommand i.e.
  <code>'button'</code> and <code>'link'</code> tags.
  These are rendered by ToolbarRenderer, so the result has
  no difference.<p />
  To add an dropdown menu to a button add a facet <code>'menupopup'</code>
  containing a
  <a href="menu.html"><code>&lt;tc:menu></code></a>
  tag to the button. Label's and Image's on those menu tag's are ignored
  and replaced by the renderer.
  <pre>
       &lt;tc:button onclick="alert('test 0')"
           label="Alert 0" &gt;
         &lt;f:facet name="menupopup"&gt;
           &lt;tc:menu&gt;
             &lt;tc:menuCommand onclick="alert('test 1')" label="Alert 1"/&gt;
             &lt;tc:menuCommand onclick="alert('test 2')" label="Alert 2"/&gt;
             &lt;tc:menuCommand onclick="alert('test 3')" label="Alert 3"/&gt;
           &lt;/tc:menu&gt;
         &lt;/f:facet&gt;
       &lt;/tc:button&gt;
       </pre>
  * UIComponent class, generated from template {@code component1.2.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.ToolBarTagDeclaration}.
 */
public class UIToolBar
    extends AbstractUIToolBar implements SupportsMarkup {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.ToolBar";

  private org.apache.myfaces.tobago.context.Markup markup;
  private org.apache.myfaces.tobago.layout.Measure marginLeft;
  private org.apache.myfaces.tobago.layout.Measure minimumHeight;
  private org.apache.myfaces.tobago.layout.Measure borderLeft;
  private java.lang.String tip;
  private org.apache.myfaces.tobago.layout.Measure height;
  private org.apache.myfaces.tobago.layout.Measure minimumWidth;
  private java.lang.Integer rowSpan;
  private org.apache.myfaces.tobago.layout.Measure left;
  private java.lang.Integer columnSpan;
  private org.apache.myfaces.tobago.layout.Measure borderRight;
  private org.apache.myfaces.tobago.layout.Measure paddingBottom;
  private org.apache.myfaces.tobago.layout.Measure maximumHeight;
  private org.apache.myfaces.tobago.layout.Measure top;
  private java.lang.String orientation;
  private org.apache.myfaces.tobago.layout.Measure currentWidth;
  private org.apache.myfaces.tobago.layout.Measure paddingTop;
  private org.apache.myfaces.tobago.layout.Measure marginTop;
  private org.apache.myfaces.tobago.layout.Measure marginRight;
  private org.apache.myfaces.tobago.layout.Measure width;
  private org.apache.myfaces.tobago.layout.Measure currentHeight;
  private org.apache.myfaces.tobago.layout.Measure preferredHeight;
  private java.lang.String labelPosition;
  private org.apache.myfaces.tobago.layout.Display display;
  private org.apache.myfaces.tobago.layout.Measure borderBottom;
  private org.apache.myfaces.tobago.layout.Measure maximumWidth;
  private org.apache.myfaces.tobago.layout.Measure paddingLeft;
  private org.apache.myfaces.tobago.layout.Measure paddingRight;
  private org.apache.myfaces.tobago.layout.Measure preferredWidth;
  private org.apache.myfaces.tobago.layout.Measure marginBottom;
  private java.lang.String iconSize;
  private java.lang.Integer verticalIndex;
  private org.apache.myfaces.tobago.layout.Measure borderTop;
  private org.apache.myfaces.tobago.context.Markup currentMarkup;
  private java.lang.Integer horizontalIndex;


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    if (markup != null) {
      return markup;
    }
    ValueExpression ve = getValueExpression("markup");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Markup.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    this.markup = markup;
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginLeft() {
    if (marginLeft != null) {
      return marginLeft;
    }
    ValueExpression ve = getValueExpression("marginLeft");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginLeft(getFacesContext(), this);
  }

  public void setMarginLeft(org.apache.myfaces.tobago.layout.Measure marginLeft) {
    this.marginLeft = marginLeft;
  }

  public org.apache.myfaces.tobago.layout.Measure getMinimumHeight() {
    if (minimumHeight != null) {
      return minimumHeight;
    }
    ValueExpression ve = getValueExpression("minimumHeight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMinimumHeight(getFacesContext(), this);
  }

  public void setMinimumHeight(org.apache.myfaces.tobago.layout.Measure minimumHeight) {
    this.minimumHeight = minimumHeight;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderLeft() {
    if (borderLeft != null) {
      return borderLeft;
    }
    ValueExpression ve = getValueExpression("borderLeft");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getBorderLeft(getFacesContext(), this);
  }

  public void setBorderLeft(org.apache.myfaces.tobago.layout.Measure borderLeft) {
    this.borderLeft = borderLeft;
  }

  /**
  Text value to display as tooltip.

  */
  public java.lang.String getTip() {
    if (tip != null) {
      return tip;
    }
    ValueExpression ve = getValueExpression("tip");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setTip(java.lang.String tip) {
    this.tip = tip;
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getHeight() {
    if (height != null) {
      return height;
    }
    ValueExpression ve = getValueExpression("height");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getHeight(getFacesContext(), this);
  }

  public void setHeight(org.apache.myfaces.tobago.layout.Measure height) {
    this.height = height;
  }

  public org.apache.myfaces.tobago.layout.Measure getMinimumWidth() {
    if (minimumWidth != null) {
      return minimumWidth;
    }
    ValueExpression ve = getValueExpression("minimumWidth");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer)getRenderer(getFacesContext())).getMinimumWidth(getFacesContext(), this);
  }

  public void setMinimumWidth(org.apache.myfaces.tobago.layout.Measure minimumWidth) {
    this.minimumWidth = minimumWidth;
  }

  public java.lang.Integer getRowSpan() {
    if (rowSpan != null) {
      return rowSpan;
    }
    ValueExpression ve = getValueExpression("rowSpan");
    if (ve != null) {
      try {
        Number number = (Number) ve.getValue(getFacesContext().getELContext());
        if (number != null) {
          return number.intValue();
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return 1;
  }

  public void setRowSpan(java.lang.Integer rowSpan) {
    this.rowSpan = rowSpan;
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getLeft() {
    if (left != null) {
      return left;
    }
    ValueExpression ve = getValueExpression("left");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setLeft(org.apache.myfaces.tobago.layout.Measure left) {
    this.left = left;
  }

  public java.lang.Integer getColumnSpan() {
    if (columnSpan != null) {
      return columnSpan;
    }
    ValueExpression ve = getValueExpression("columnSpan");
    if (ve != null) {
      try {
        Number number = (Number) ve.getValue(getFacesContext().getELContext());
        if (number != null) {
          return number.intValue();
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return 1;
  }

  public void setColumnSpan(java.lang.Integer columnSpan) {
    this.columnSpan = columnSpan;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderRight() {
    if (borderRight != null) {
      return borderRight;
    }
    ValueExpression ve = getValueExpression("borderRight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getBorderRight(getFacesContext(), this);
  }

  public void setBorderRight(org.apache.myfaces.tobago.layout.Measure borderRight) {
    this.borderRight = borderRight;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingBottom() {
    if (paddingBottom != null) {
      return paddingBottom;
    }
    ValueExpression ve = getValueExpression("paddingBottom");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingBottom(getFacesContext(), this);
  }

  public void setPaddingBottom(org.apache.myfaces.tobago.layout.Measure paddingBottom) {
    this.paddingBottom = paddingBottom;
  }

  public org.apache.myfaces.tobago.layout.Measure getMaximumHeight() {
    if (maximumHeight != null) {
      return maximumHeight;
    }
    ValueExpression ve = getValueExpression("maximumHeight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMaximumHeight(getFacesContext(), this);
  }

  public void setMaximumHeight(org.apache.myfaces.tobago.layout.Measure maximumHeight) {
    this.maximumHeight = maximumHeight;
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getTop() {
    if (top != null) {
      return top;
    }
    ValueExpression ve = getValueExpression("top");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setTop(org.apache.myfaces.tobago.layout.Measure top) {
    this.top = top;
  }

  /**
  Orientation of toolbar
  <br />Default: <code>left</code><br />Allowed Values: <code>left,right</code>
  */
  public java.lang.String getOrientation() {
    if (orientation != null) {
      return orientation;
    }
    ValueExpression ve = getValueExpression("orientation");
    if (ve != null) {
      try {
        java.lang.String orientation = (java.lang.String) ve.getValue(getFacesContext().getELContext());
        if (orientation != null) {
          return orientation;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return "left";
  }

  public void setOrientation(java.lang.String orientation) {
    this.orientation = orientation;
  }

  /**
  This value will usually be set by the layout manager. It holds the current width computed by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getCurrentWidth() {
    if (currentWidth != null) {
      return currentWidth;
    }
    ValueExpression ve = getValueExpression("currentWidth");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return getWidth();
  }

  public void setCurrentWidth(org.apache.myfaces.tobago.layout.Measure currentWidth) {
    this.currentWidth = currentWidth;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingTop() {
    if (paddingTop != null) {
      return paddingTop;
    }
    ValueExpression ve = getValueExpression("paddingTop");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingTop(getFacesContext(), this);
  }

  public void setPaddingTop(org.apache.myfaces.tobago.layout.Measure paddingTop) {
    this.paddingTop = paddingTop;
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginTop() {
    if (marginTop != null) {
      return marginTop;
    }
    ValueExpression ve = getValueExpression("marginTop");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginTop(getFacesContext(), this);
  }

  public void setMarginTop(org.apache.myfaces.tobago.layout.Measure marginTop) {
    this.marginTop = marginTop;
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginRight() {
    if (marginRight != null) {
      return marginRight;
    }
    ValueExpression ve = getValueExpression("marginRight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginRight(getFacesContext(), this);
  }

  public void setMarginRight(org.apache.myfaces.tobago.layout.Measure marginRight) {
    this.marginRight = marginRight;
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getWidth() {
    if (width != null) {
      return width;
    }
    ValueExpression ve = getValueExpression("width");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getWidth(getFacesContext(), this);
  }

  public void setWidth(org.apache.myfaces.tobago.layout.Measure width) {
    this.width = width;
  }

  /**
  This value will usually be set by the layout manager. It holds the current height computed by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getCurrentHeight() {
    if (currentHeight != null) {
      return currentHeight;
    }
    ValueExpression ve = getValueExpression("currentHeight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return getHeight();
  }

  public void setCurrentHeight(org.apache.myfaces.tobago.layout.Measure currentHeight) {
    this.currentHeight = currentHeight;
  }

  public org.apache.myfaces.tobago.layout.Measure getPreferredHeight() {
    if (preferredHeight != null) {
      return preferredHeight;
    }
    ValueExpression ve = getValueExpression("preferredHeight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getPreferredHeight(getFacesContext(), this);
  }

  public void setPreferredHeight(org.apache.myfaces.tobago.layout.Measure preferredHeight) {
    this.preferredHeight = preferredHeight;
  }

  /**
  Position of the button label, possible values are: right, bottom, off.
   If toolbar is facet of box: bottom is changed to right!
  <br />Default: <code>bottom</code><br />Allowed Values: <code>bottom,right,off</code>
  */
  public java.lang.String getLabelPosition() {
    if (labelPosition != null) {
      return labelPosition;
    }
    ValueExpression ve = getValueExpression("labelPosition");
    if (ve != null) {
      try {
        java.lang.String labelPosition = (java.lang.String) ve.getValue(getFacesContext().getELContext());
        if (labelPosition != null) {
          return labelPosition;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return "bottom";
  }

  public void setLabelPosition(java.lang.String labelPosition) {
    this.labelPosition = labelPosition;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Display getDisplay() {
    if (display != null) {
      return display;
    }
    ValueExpression ve = getValueExpression("display");
    if (ve != null) {
      try {
        return (org.apache.myfaces.tobago.layout.Display) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setDisplay(org.apache.myfaces.tobago.layout.Display display) {
    this.display = display;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderBottom() {
    if (borderBottom != null) {
      return borderBottom;
    }
    ValueExpression ve = getValueExpression("borderBottom");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getBorderBottom(getFacesContext(), this);
  }

  public void setBorderBottom(org.apache.myfaces.tobago.layout.Measure borderBottom) {
    this.borderBottom = borderBottom;
  }

  public org.apache.myfaces.tobago.layout.Measure getMaximumWidth() {
    if (maximumWidth != null) {
      return maximumWidth;
    }
    ValueExpression ve = getValueExpression("maximumWidth");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMaximumWidth(getFacesContext(), this);
  }

  public void setMaximumWidth(org.apache.myfaces.tobago.layout.Measure maximumWidth) {
    this.maximumWidth = maximumWidth;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingLeft() {
    if (paddingLeft != null) {
      return paddingLeft;
    }
    ValueExpression ve = getValueExpression("paddingLeft");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingLeft(getFacesContext(), this);
  }

  public void setPaddingLeft(org.apache.myfaces.tobago.layout.Measure paddingLeft) {
    this.paddingLeft = paddingLeft;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingRight() {
    if (paddingRight != null) {
      return paddingRight;
    }
    ValueExpression ve = getValueExpression("paddingRight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingRight(getFacesContext(), this);
  }

  public void setPaddingRight(org.apache.myfaces.tobago.layout.Measure paddingRight) {
    this.paddingRight = paddingRight;
  }

  public org.apache.myfaces.tobago.layout.Measure getPreferredWidth() {
    if (preferredWidth != null) {
      return preferredWidth;
    }
    ValueExpression ve = getValueExpression("preferredWidth");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getPreferredWidth(getFacesContext(), this);
  }

  public void setPreferredWidth(org.apache.myfaces.tobago.layout.Measure preferredWidth) {
    this.preferredWidth = preferredWidth;
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginBottom() {
    if (marginBottom != null) {
      return marginBottom;
    }
    ValueExpression ve = getValueExpression("marginBottom");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginBottom(getFacesContext(), this);
  }

  public void setMarginBottom(org.apache.myfaces.tobago.layout.Measure marginBottom) {
    this.marginBottom = marginBottom;
  }

  /**
  Size of button images, possible values are: small, big, off.
  <br />Default: <code>small</code><br />Allowed Values: <code>small,big,off</code>
  */
  public java.lang.String getIconSize() {
    if (iconSize != null) {
      return iconSize;
    }
    ValueExpression ve = getValueExpression("iconSize");
    if (ve != null) {
      try {
        java.lang.String iconSize = (java.lang.String) ve.getValue(getFacesContext().getELContext());
        if (iconSize != null) {
          return iconSize;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return "small";
  }

  public void setIconSize(java.lang.String iconSize) {
    this.iconSize = iconSize;
  }

  /**
  This attribute is for internal use only.

  */
  public java.lang.Integer getVerticalIndex() {
    if (verticalIndex != null) {
      return verticalIndex;
    }
    ValueExpression ve = getValueExpression("verticalIndex");
    if (ve != null) {
      try {
        Number number = (Number) ve.getValue(getFacesContext().getELContext());
        if (number != null) {
          return number.intValue();
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setVerticalIndex(java.lang.Integer verticalIndex) {
    this.verticalIndex = verticalIndex;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderTop() {
    if (borderTop != null) {
      return borderTop;
    }
    ValueExpression ve = getValueExpression("borderTop");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getBorderTop(getFacesContext(), this);
  }

  public void setBorderTop(org.apache.myfaces.tobago.layout.Measure borderTop) {
    this.borderTop = borderTop;
  }

  public org.apache.myfaces.tobago.context.Markup getCurrentMarkup() {
    if (currentMarkup != null) {
      return currentMarkup;
    }
    ValueExpression ve = getValueExpression("currentMarkup");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Markup.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setCurrentMarkup(org.apache.myfaces.tobago.context.Markup currentMarkup) {
    this.currentMarkup = currentMarkup;
  }

  /**
  This attribute is for internal use only.

  */
  public java.lang.Integer getHorizontalIndex() {
    if (horizontalIndex != null) {
      return horizontalIndex;
    }
    ValueExpression ve = getValueExpression("horizontalIndex");
    if (ve != null) {
      try {
        Number number = (Number) ve.getValue(getFacesContext().getELContext());
        if (number != null) {
          return number.intValue();
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setHorizontalIndex(java.lang.Integer horizontalIndex) {
    this.horizontalIndex = horizontalIndex;
  }

  public void restoreState(FacesContext context, Object componentState) {
    Object[] values = (Object[]) componentState;
    super.restoreState(context, values[0]);
    markup = (org.apache.myfaces.tobago.context.Markup) values[1];
    marginLeft = (org.apache.myfaces.tobago.layout.Measure) values[2];
    minimumHeight = (org.apache.myfaces.tobago.layout.Measure) values[3];
    borderLeft = (org.apache.myfaces.tobago.layout.Measure) values[4];
    tip = (java.lang.String) values[5];
    height = (org.apache.myfaces.tobago.layout.Measure) values[6];
    minimumWidth = (org.apache.myfaces.tobago.layout.Measure) values[7];
    rowSpan = (java.lang.Integer) values[8];
    left = (org.apache.myfaces.tobago.layout.Measure) values[9];
    columnSpan = (java.lang.Integer) values[10];
    borderRight = (org.apache.myfaces.tobago.layout.Measure) values[11];
    paddingBottom = (org.apache.myfaces.tobago.layout.Measure) values[12];
    maximumHeight = (org.apache.myfaces.tobago.layout.Measure) values[13];
    top = (org.apache.myfaces.tobago.layout.Measure) values[14];
    orientation = (java.lang.String) values[15];
    currentWidth = (org.apache.myfaces.tobago.layout.Measure) values[16];
    paddingTop = (org.apache.myfaces.tobago.layout.Measure) values[17];
    marginTop = (org.apache.myfaces.tobago.layout.Measure) values[18];
    marginRight = (org.apache.myfaces.tobago.layout.Measure) values[19];
    width = (org.apache.myfaces.tobago.layout.Measure) values[20];
    currentHeight = (org.apache.myfaces.tobago.layout.Measure) values[21];
    preferredHeight = (org.apache.myfaces.tobago.layout.Measure) values[22];
    labelPosition = (java.lang.String) values[23];
    display = (org.apache.myfaces.tobago.layout.Display) values[24];
    borderBottom = (org.apache.myfaces.tobago.layout.Measure) values[25];
    maximumWidth = (org.apache.myfaces.tobago.layout.Measure) values[26];
    paddingLeft = (org.apache.myfaces.tobago.layout.Measure) values[27];
    paddingRight = (org.apache.myfaces.tobago.layout.Measure) values[28];
    preferredWidth = (org.apache.myfaces.tobago.layout.Measure) values[29];
    marginBottom = (org.apache.myfaces.tobago.layout.Measure) values[30];
    iconSize = (java.lang.String) values[31];
    verticalIndex = (java.lang.Integer) values[32];
    borderTop = (org.apache.myfaces.tobago.layout.Measure) values[33];
    currentMarkup = (org.apache.myfaces.tobago.context.Markup) values[34];
    horizontalIndex = (java.lang.Integer) values[35];
  }

  public Object saveState(FacesContext context) {
    Object[] values = new Object[36];
    values[0] = super.saveState(context);
    values[1] = markup;
    values[2] = marginLeft;
    values[3] = minimumHeight;
    values[4] = borderLeft;
    values[5] = tip;
    values[6] = height;
    values[7] = minimumWidth;
    values[8] = rowSpan;
    values[9] = left;
    values[10] = columnSpan;
    values[11] = borderRight;
    values[12] = paddingBottom;
    values[13] = maximumHeight;
    values[14] = top;
    values[15] = orientation;
    values[16] = currentWidth;
    values[17] = paddingTop;
    values[18] = marginTop;
    values[19] = marginRight;
    values[20] = width;
    values[21] = currentHeight;
    values[22] = preferredHeight;
    values[23] = labelPosition;
    values[24] = display;
    values[25] = borderBottom;
    values[26] = maximumWidth;
    values[27] = paddingLeft;
    values[28] = paddingRight;
    values[29] = preferredWidth;
    values[30] = marginBottom;
    values[31] = iconSize;
    values[32] = verticalIndex;
    values[33] = borderTop;
    values[34] = currentMarkup;
    values[35] = horizontalIndex;
    return values;
  }


}